=== modified file 'debian/changelog'
--- debian/changelog	2009-12-13 12:06:07 +0000
+++ debian/changelog	2009-12-29 22:18:35 +0000
@@ -1,3 +1,13 @@
+expat (2.0.1-7) unstable; urgency=low
+
+  * debian/control (Depends): Fixed debhelper-but-no-misc-depends.
+  * debian/patches/560901_CVE_2009_3560.dpatch: Adjusted.
+    - lib/xmlparse.c (doProlog): Revised patch for CVE-2009-3560 after
+      regressions have been detected (closes: #561658). Many thanks to
+      Niko Tyni and Karl Waclawek for their help and the fix.
+
+ -- Daniel Leidert (dale) <daniel.leidert@wgdd.de>  Tue, 29 Dec 2009 22:18:35 +0100
+
 expat (2.0.1-6) unstable; urgency=medium
 
   * debian/patches/560901_CVE_2009_3560.dpatch: Added.

=== modified file 'debian/control'
--- debian/control	2009-11-03 22:41:38 +0000
+++ debian/control	2009-12-29 22:18:35 +0000
@@ -15,7 +15,7 @@
 Package: lib64expat1-dev
 Section: libdevel
 Architecture: i386 powerpc sparc s390
-Depends: lib64expat1 (= ${binary:Version}), libexpat1-dev, gcc-multilib
+Depends: ${misc:Depends}, lib64expat1 (= ${binary:Version}), libexpat1-dev, gcc-multilib
 Description: XML parsing C library - development kit (64bit)
  This package contains the header file and development libraries of
  expat, the C library for parsing XML.  Expat is a stream oriented XML
@@ -31,7 +31,7 @@
 Package: lib64expat1
 Section: libs
 Architecture: i386 powerpc sparc s390
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: XML parsing C library - runtime library (64bit)
  This package contains the runtime, shared library of expat, the C
  library for parsing XML. Expat is a stream-oriented parser in
@@ -45,7 +45,7 @@
 Architecture: any
 Provides: libexpat-dev
 Conflicts: libexpat-dev
-Depends: libexpat1 (= ${binary:Version}), libc6-dev | libc-dev
+Depends: ${misc:Depends}, libexpat1 (= ${binary:Version}), libc6-dev | libc-dev
 Description: XML parsing C library - development kit
  This package contains the header file and development libraries of
  expat, the C library for parsing XML.  Expat is a stream oriented XML
@@ -59,7 +59,7 @@
 Section: libs
 Architecture: any
 Conflicts: wink (<= 1.5.1060-4)
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: XML parsing C library - runtime library
  This package contains the runtime, shared library of expat, the C
  library for parsing XML. Expat is a stream-oriented parser in
@@ -71,14 +71,14 @@
 Section: debian-installer
 Priority: extra
 Architecture: any
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: XML parsing C library - runtime library
  This package contains the runtime, shared library of expat, the C
  library for parsing XML.
 
 Package: expat
 Architecture: any
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: XML parsing C library - example application
  This package contains xmlwf, an example application of expat, the C
  library for parsing XML.  The arguments to xmlwf are one or more

=== modified file 'debian/patches/560901_CVE_2009_3560.dpatch'
--- debian/patches/560901_CVE_2009_3560.dpatch	2009-12-13 12:06:07 +0000
+++ debian/patches/560901_CVE_2009_3560.dpatch	2009-12-29 22:18:35 +0000
@@ -9,20 +9,26 @@
 ## DP: to the doProlog function in lib/xmlparse.c, a different vulnerability
 ## DP: than CVE-2009-2625 and CVE-2009-3720. 
 ## DP:
+## DP: This is the revised patch.
+## DP:
 ## DP: <URL:http://bugs.debian.org/560901>
+## DP: <URL:http://bugs.debian.org/561658>
 ## DP: <URL:http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2009-3560>
-## DP: <URL:http://expat.cvs.sourceforge.net/viewvc/expat/expat/lib/xmlparse.c?r1=1.164&r2=1.165>
+## DP: <URL:http://expat.cvs.sourceforge.net/viewvc/expat/expat/lib/xmlparse.c?r1=1.164&r2=1.166>
+## DP: <URL:http://expat.cvs.sourceforge.net/viewvc/expat/expat/lib/xmlparse.c?view=log#rev1.166>
 ## DP: <URL:http://expat.cvs.sourceforge.net/viewvc/expat/expat/lib/xmlparse.c?view=log#rev1.165>
 
 @DPATCH@
-diff -urNad lenny~/lib/xmlparse.c lenny/lib/xmlparse.c
---- lenny~/lib/xmlparse.c	2007-05-08 04:25:35.000000000 +0200
-+++ lenny/lib/xmlparse.c	2009-12-13 11:39:18.671629559 +0100
-@@ -3725,7 +3725,6 @@
-         return XML_ERROR_NO_ELEMENTS;
-       default:
-         tok = -tok;
--        next = end;
-         break;
-       }
-     }
+diff -urNad trunk~/lib/xmlparse.c trunk/lib/xmlparse.c
+--- trunk~/lib/xmlparse.c	2007-05-08 04:25:35.000000000 +0200
++++ trunk/lib/xmlparse.c	2009-12-29 21:57:22.141732904 +0100
+@@ -3703,6 +3703,9 @@
+         return XML_ERROR_UNCLOSED_TOKEN;
+       case XML_TOK_PARTIAL_CHAR:
+         return XML_ERROR_PARTIAL_CHAR;
++      case -XML_TOK_PROLOG_S:
++        tok = -tok;
++        break;
+       case XML_TOK_NONE:
+ #ifdef XML_DTD
+         /* for internal PE NOT referenced between declarations */

